<?php
/**
*
* Mod Who download this??
* 
* @copyright (c) 2012 Kazekage
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/who_download_this');

$mode = request_var('mode', '');
$id = (int) request_var('id', '0');

if (empty($id) or empty($mode) or ($mode != 'user' xor $mode == 'file' )) 
{
trigger_error($user->lang['NO_VALID'] .'<br><br><a href=' . append_sid($phpbb_root_path . 'index.' . $phpEx) . '>' . $user->lang['GOTO_INDEX'] . '</a>');
}

if ($mode == 'file' and !$auth->acl_get('u_view_download_list') or $mode == 'user' and !$auth->acl_get('u_view_users_downloads')) 
{
trigger_error($user->lang['NO_AUTH'] .'<br><br><a href=' . append_sid($phpbb_root_path . 'index.' . $phpEx) . '>' . $user->lang['GOTO_INDEX'] . '</a>');
}
 
 // Las variables del ordenamiento
$sb = request_var('sb', '');
$so = request_var('so', '');

// Build the pagination
$limit = request_var('limit', $config['topics_per_page']);
$start = request_var('start', 0);
$pagination_url = append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode=' . $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . (($sb) ? '&sb=' . $sb : '') . (($so) ? '&so=' . $so : ''));

 
 switch ($sb) {
  case 'a':
   $sb= ($mode == 'file') ? 'u.username' : 'a.real_filename';
   break;
  case 'b':
   $sb= 'ad.count_download';
   break;
  case 'c':
   $sb= ($mode == 'file') ? 'ad.last_download' : 'p.post_subject';
   break;
  default:
   $sb= 'ad.last_download';
   break;  
  }
  if (!$so) {$sb .= ' DESC';} else {$sb .= ' ASC';}
  
 $a =  false;
 
if ($mode == 'file')
{  

$sql = 'SELECT ad.*, u.user_id, u.username, u.user_colour '.
	' FROM ' . ATTACHMENTS_DOWNLOADS_TABLE . ' ad, ' . USERS_TABLE . ' u ' .
	' WHERE ad.file_id = ' . $id . ' AND u.user_id = ad.user_id' .
	' ORDER BY ' . $sb;
	
$result = $db->sql_query_limit($sql, $limit, $start);

while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('filelist', array(
		'USERNAME'		=> get_username_string('full', $row['user_id'], (($row['user_id'] != ANONYMOUS) ? $row['username'] : $user->lang['GUEST']), $row['user_colour']),
		'TOTAL_COUNT'		=> $row['count_download'],
		'LAST_DOWNLOAD'	=> $user->format_date($row['last_download']),
		));
		$a = true;
}
$db->sql_freeresult($result);
unset($row, $sb);

$db->sql_query('SELECT real_filename FROM ' . ATTACHMENTS_TABLE . ' WHERE attach_id = ' . $id);
$title = $db->sql_fetchfield('real_filename');
$db->sql_freeresult();

$db->sql_query('SELECT COUNT(user_id) as total FROM ' . ATTACHMENTS_DOWNLOADS_TABLE . ' WHERE file_id = ' . $id);
$total = $db->sql_fetchfield('total');
$db->sql_freeresult();

$template->assign_vars(array(
	'U_SB_USERNAME'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode='. $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '' ). '&sb=a' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_TOTAL_COUNT'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode='. $mode  .(($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '' ). '&sb=b' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_LAST_DOWNLOAD'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode='. $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '' ). '&sb=c' . (($so) ? '&so=0' : '&so=1')),
));

$template->set_filenames(array(
	'body'	=> 'attach_user_list.html',
));

} else {

$sql = 'SELECT a.real_filename, a.attach_id, a.post_msg_id,  p.post_subject, p.post_id, p.forum_id, p.topic_id, ad.file_id, ad.count_download, ad.last_download '.
	' FROM ' . ATTACHMENTS_DOWNLOADS_TABLE . ' ad, ' . POSTS_TABLE . ' p, ' . ATTACHMENTS_TABLE . ' a ' .
	' WHERE a.attach_id = ad.file_id AND a.post_msg_id = p.post_id AND ad.user_id = ' . $id .
	' ORDER BY ' . $sb;
	
$result = $db->sql_query_limit($sql, $limit, $start);

while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('filelist', array(
		'FILENAME'		=> $row['real_filename'],
		'U_FILENAME'		=> append_sid("{$phpbb_root_path}download/file.$phpEx", 'id='. $row['file_id'] ),
		'POSTNAME'		=> $row['post_subject'],
		'U_POSTNAME'		=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f='. $row['forum_id'] .'&t='. $row['topic_id'] . '#p'.$row['post_id']),
		'TOTAL_COUNT'		=> $row['count_download'],
		'LAST_DOWNLOAD'	=> $user->format_date($row['last_download']),
	));
	$a = true;
}
$db->sql_freeresult($result);
unset($row, $sb);

$db->sql_query('SELECT username FROM ' . USERS_TABLE . ' WHERE user_id = ' . $id);
$title = $db->sql_fetchfield('username');
$db->sql_freeresult();

$db->sql_query('SELECT COUNT(file_id) as total FROM ' . ATTACHMENTS_DOWNLOADS_TABLE . ' WHERE user_id = ' . $id);
$total = $db->sql_fetchfield('total');
$db->sql_freeresult();

$template->assign_vars(array(
	'U_SB_FILENAME'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode=' . $mode . '&mode=' . $mode. (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=a' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_POSTNAME'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode=' . $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=c' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_TOTAL_COUNT'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode=' . $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=b' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_LAST_DOWNLOAD'	=> append_sid($phpbb_root_path . 'download/index.' . $phpEx, 'id=' . $id . '&mode=' . $mode . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=d' . (($so) ? '&so=0' : '&so=1')),
));

$template->set_filenames(array(
	'body'	=> 'attach_file_list.html',
));
}

if (!empty($a))
{
$page_title = sprintf($user->lang[(($mode == 'file') ? 'FILE_TITLE' : 'USER_TITLE')], $title);
} else {
$page_title =$user->lang['INFO'];
}

page_header($page_title);

$template->assign_vars(array(
	'TITLE'			=> $page_title,
	'PAGINATION'	=> generate_pagination($pagination_url, $total, $limit, $start),
	'PAGE_NUMBER'	=> on_page($total, $limit, $start),
	'TOTAL'	=> ($total == 1) ? $user->lang['LIST_ELEMENT'] : sprintf($user->lang['LIST_ELEMENTS'], $total),
));

// Send the page footer
page_footer(false);

?>